/*
 *  flow.c
 *  This program animates the flowfield.
 */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <GL/glut.h>

int n2;
float px,py,xp[13],yp[13];
int width0, height0;

void FlowDisplay(void)
{


	FILE *box;               /* input file pointer */
        int n,i;  
        float x,y;  
        box = fopen( "box", "r" );
	n=4;

    	glClear (GL_COLOR_BUFFER_BIT);

	glLoadIdentity ();
	glTranslatef (-4, -7, -0);

	/*glRotatef (45.0, .01, 0.003,0);*/

	glutWireCube(1.0);
        glClear (GL_COLOR_BUFFER_BIT| GL_DEPTH_BUFFER_BIT);
	glColor3f(1.0, 1.0, 1.0);
	/* This routine plots the fluid particals */

        /*if( n2 < 60 )
	{
        }*/

        for( i = 1; i <= 12; ++i )
	{
	   glBegin(GL_TRIANGLES);
	 	    glVertex2f(xp[i],yp[i]);
	 	    glVertex2f(xp[i]+.2,yp[i]+.2);
	 	    glVertex2f(xp[i]+.2,yp[i]);
	   glEnd();
	}

	glBegin(GL_POLYGON);
           for( i = 1; i <= n; ++i )
        	{
               	    fscanf( box, "%f %f \n ", &x, &y );
                    /*printf( "%9.5f %9.5f \n",x,y);*/
	 	    glVertex2f(x,y);
        	}
	glEnd();
	glFlush();
        glPopMatrix();
        glutSwapBuffers();
	/*sleep (10);*/
}

void FlowReshape(int w, int h)
{
        double ratio;
        int width, height;

        width = w;
        height = h;

        ratio = (double) width / (double) height;

        glViewport (0, 0, width, height);    /*  define the viewport */
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
        glOrtho(-.0, 15.0, -6.0, 6.0, -1., 5.);
        glMatrixMode (GL_MODELVIEW);       /*  back to modelview matrix    */

#if 0
        glViewport (0, 0, width, height);    /*  define the viewport */
        glMatrixMode (GL_PROJECTION);       /*  prepare for and then  */
        glLoadIdentity ();  /*  define the projection  */

        glFrustum (-2.5, 2.5, -2.5, 2.5,1, 80.0);
        glMatrixMode (GL_MODELVIEW);       /*  back to modelview matrix    */
        glLoadIdentity();
#endif
}



void reader(void)
{
	FILE *o3;               /* input file pointer */
	int j,j2;
        o3 = fopen( "o3", "r" );
	n2=n2+1;
	j2=1;
        /*if( n2 < 60 )*/
        for( j = 1; j <= n2*12; ++j )
	{
/* here for mod */
            fscanf( o3, "%f %f \n ", &px,&py);

/* To slow down the program, include this print statement */
            printf( "%4i \n",n2);

            if( j > (n2-1)*12 )
            {
		xp[j2]=px;yp[j2]=py;
		j2=j2+1;
            }
        }
	FlowDisplay();

}


void FlowInit (void) 
{
    /*  background to be cleared to black       */
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glShadeModel (GL_FLAT);
}



int main(int argc, char** argv)
{
    int m,m2, FlowWindow;
#if 0
    auxInitDisplayMode (AUX_SINGLE | AUX_RGB);
    auxInitPosition (30, 20, 500, 500);
    auxInitWindow (argv[0]);
    myinit ();
    /*auxIdleFunc(reader);
    auxMainLoop(display);*/
#endif

        width0=500;
        height0=500;

        glutInit(&argc, argv);
        glutInitWindowSize(width0, height0);
        glutInitWindowPosition(0,0);
        glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
        FlowWindow = glutCreateWindow("Flow");
        FlowInit();

        glutIdleFunc( reader );
        glutReshapeFunc(FlowReshape);
        glutDisplayFunc(FlowDisplay);
        glutMainLoop();


    n2=0;
    /*for( m2 = 1; m2 <= 20; ++m2 )*/
    {
            for( m = 1; m <= 60; ++m )
            {	
		/*display();*/
		reader();
            }
	    n2=1;
    }

}

